Loading...
Searching...
No Matches
pappso::masschroq::PeptideBase Class Reference

`#include <peptidebase.h>`

Inheritance diagram for pappso::masschroq::PeptideBase:

## Public Member Functions

| PeptideBase (const pappso::PeptideSp &peptide_sp)
virtual | ~PeptideBase ()
virtual const pappso::PeptideSp & | getPappsoPeptideSp () const
| get the peptide sequence
virtual void | computeIsotopologues (double ni_min_abundance)
| compute possible isotopes for this molecule
virtual const pappso::PeptideNaturalIsotopeList * | getPeptideNaturalIsotopeList () const
| get list of isotopes for this peptide needs computeIsotopologues before
virtual const std::vector< pappso::PeptideNaturalIsotopeAverageSp > & | getPeptideNaturalIsotopeAverageSpList (pappso::PrecisionPtr precision, std::uint8_t charge, double ni_min_abundance)
| get possible and distinguishable masses of isotopes get list of distinguishable isotopes given the charge and mass precision

## Protected Attributes

const pappso::PeptideSp | msp_peptide
pappso::PeptideNaturalIsotopeList * | mpa_peptideNaturalIsotopeList = nullptr
std::map< std::uint8_t, std::vector< pappso::PeptideNaturalIsotopeAverageSp > > | m_peptideNaturalIsotopeAverageSpListByCharge
double | m_niMinAbundance = 0
QMutex | m_mutex

## Detailed Description

Todo
  write docs

Definition at line 39 of file peptidebase.h.

## Constructor & Destructor Documentation

## PeptideBase()

pappso::masschroq::PeptideBase::PeptideBase | ( | const pappso::PeptideSp & | peptide_sp | ) |

Default constructor

Definition at line 31 of file peptidebase.cpp.

: msp_peptide(peptide_sp)
{
}
pappso::masschroq::PeptideBase::msp_peptide
const pappso::PeptideSp msp_peptide
Definition peptidebase.h:88

References msp_peptide.

Referenced by pappso::masschroq::Peptide::Peptide(), pappso::masschroq::Peptide::Peptide(), and pappso::masschroq::PeptideLabel::PeptideLabel().

## ~PeptideBase()

pappso::masschroq::PeptideBase::~PeptideBase | ( |  | ) |

virtual

Destructor

Definition at line 36 of file peptidebase.cpp.

{
}

## Member Function Documentation

## computeIsotopologues()

void pappso::masschroq::PeptideBase::computeIsotopologues | ( | double | ni_min_abundance | ) |

virtual

compute possible isotopes for this molecule

Parameters

  ni_min_abundance | the minimal isotop abundance proportion to cover (0.9 will compute isotopes to reach at least 90% of its theoretical abundance

Reimplemented in pappso::masschroq::Peptide.

Definition at line 48 of file peptidebase.cpp.

{
qDebug();
if(ni_min_abundance > 0)
{
qDebug() << "if (_minimum_isotope_abundance > 0)";
mpa_peptideNaturalIsotopeList = new pappso::PeptideNaturalIsotopeList(msp_peptide, 0.001);
}
qDebug();
}
pappso::masschroq::PeptideBase::mpa_peptideNaturalIsotopeList
pappso::PeptideNaturalIsotopeList * mpa_peptideNaturalIsotopeList
Definition peptidebase.h:89

References mpa_peptideNaturalIsotopeList, and msp_peptide.

Referenced by pappso::masschroq::Peptide::computeIsotopologues().

## getPappsoPeptideSp()

const pappso::PeptideSp & pappso::masschroq::PeptideBase::getPappsoPeptideSp | ( |  | ) | const

virtual

get the peptide sequence

Returns
  pappso::PeptideSp const reference

Definition at line 42 of file peptidebase.cpp.

{
return msp_peptide;
}

References msp_peptide.

Referenced by pappso::masschroq::PeptideMeasurementsBase::prepareMeasurementsForPeptide(), pappso::masschroq::CborOutputStream::writeMbrPeptideMeasurements(), and pappso::masschroq::CborOutputStream::writePeptideMeasurements().

## getPeptideNaturalIsotopeAverageSpList()

const std::vector< pappso::PeptideNaturalIsotopeAverageSp > & pappso::masschroq::PeptideBase::getPeptideNaturalIsotopeAverageSpList | ( | pappso::PrecisionPtr | precision,
|  | std::uint8_t | charge,
|  | double | ni_min_abundance )

virtual

get possible and distinguishable masses of isotopes get list of distinguishable isotopes given the charge and mass precision

Parameters

  precision | mass spectrometer MS1 precision
  charge | number of H+
  ni_min_abundance | select isotopes to regroup

Returns
  std::vector<pappso::PeptideNaturalIsotopeAverageSp> list

Definition at line 67 of file peptidebase.cpp.

{
QMutexLocker lock(&m_mutex);
if(m_niMinAbundance == ni_min_abundance)
{
}
else
{
m_peptideNaturalIsotopeAverageSpListByCharge.clear();
m_niMinAbundance = ni_min_abundance;
}
auto it = m_peptideNaturalIsotopeAverageSpListByCharge.find(charge);
if(it != m_peptideNaturalIsotopeAverageSpListByCharge.end())
{
if(it->second.size() == 0)
{
it->second =
mpa_peptideNaturalIsotopeList->getByIntensityRatio(charge, precision, ni_min_abundance);
}
return it->second;
}
else
{
auto it_insert = m_peptideNaturalIsotopeAverageSpListByCharge.insert(
{charge,
mpa_peptideNaturalIsotopeList->getByIntensityRatio(charge, precision, ni_min_abundance)});
return it_insert.first->second;
}
}
pappso::masschroq::PeptideBase::m_niMinAbundance
double m_niMinAbundance
Definition peptidebase.h:92
pappso::masschroq::PeptideBase::m_mutex
QMutex m_mutex
Definition peptidebase.h:93
pappso::masschroq::PeptideBase::m_peptideNaturalIsotopeAverageSpListByCharge
std::map< std::uint8_t, std::vector< pappso::PeptideNaturalIsotopeAverageSp > > m_peptideNaturalIsotopeAverageSpListByCharge
Definition peptidebase.h:91

References m_mutex, m_niMinAbundance, m_peptideNaturalIsotopeAverageSpListByCharge, and mpa_peptideNaturalIsotopeList.

Referenced by pappso::masschroq::PeptideMeasurementsBase::generateMeasurementsForIsotopeList().

## getPeptideNaturalIsotopeList()

const pappso::PeptideNaturalIsotopeList * pappso::masschroq::PeptideBase::getPeptideNaturalIsotopeList | ( |  | ) | const

virtual

get list of isotopes for this peptide needs computeIsotopologues before

Returns
  pappso::PeptideNaturalIsotopeList pointer to all possible isotopes (C13, H2, N15...)

Definition at line 61 of file peptidebase.cpp.

{
return mpa_peptideNaturalIsotopeList;
}

References mpa_peptideNaturalIsotopeList.

## Member Data Documentation

## m_mutex

QMutex pappso::masschroq::PeptideBase::m_mutex

protected

Definition at line 93 of file peptidebase.h.

Referenced by getPeptideNaturalIsotopeAverageSpList().

## m_niMinAbundance

double pappso::masschroq::PeptideBase::m_niMinAbundance = 0

protected

Definition at line 92 of file peptidebase.h.

Referenced by getPeptideNaturalIsotopeAverageSpList().

## m_peptideNaturalIsotopeAverageSpListByCharge

std::map<std::uint8_t, std::vector<pappso::PeptideNaturalIsotopeAverageSp> > pappso::masschroq::PeptideBase::m_peptideNaturalIsotopeAverageSpListByCharge

protected

Definition at line 91 of file peptidebase.h.

Referenced by getPeptideNaturalIsotopeAverageSpList().

## mpa_peptideNaturalIsotopeList

pappso::PeptideNaturalIsotopeList* pappso::masschroq::PeptideBase::mpa_peptideNaturalIsotopeList = nullptr

protected

Definition at line 89 of file peptidebase.h.

Referenced by pappso::masschroq::Peptide::~Peptide(), pappso::masschroq::PeptideLabel::~PeptideLabel(), computeIsotopologues(), getPeptideNaturalIsotopeAverageSpList(), and getPeptideNaturalIsotopeList().

## msp_peptide

const pappso::PeptideSp pappso::masschroq::PeptideBase::msp_peptide

protected

Definition at line 88 of file peptidebase.h.

Referenced by pappso::masschroq::Peptide::Peptide(), PeptideBase(), computeIsotopologues(), and getPappsoPeptideSp().

The documentation for this class was generated from the following files:

- pappsomspp/core/masschroq/peptidebase.h
- pappsomspp/core/masschroq/peptidebase.cpp